#!/usr/bin/env python3
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
import seaborn as sns
sns.set_context('talk')

if __name__ == '__main__':
  df = pd.read_json('times.json').sort_values('n')
  methods = df.method.unique()
  methods.sort()

  fig, ax = plt.subplots(1, 1)
  for m in methods:
    sel = df.method == m
    x = df.loc[sel, 'n']
    y = df.loc[sel, 'time']
    print(m, np.polyfit(np.log(x), np.log(y), 1))
    ax.loglog(x, y, label='method %d' % m)
  ax.legend()
  ax.set_xlabel('matrix size')
  ax.set_ylabel('run time (s)')
  fig.tight_layout()
  fig.savefig('lsapr-times.png', dpi=320)
  plt.show()
# end __main__
