#!/usr/bin/env python3
import os
import sys
import numpy as np

if __name__ == '__main__':

  #n = 16  # size of each matrix
  n = int(sys.argv[1])
  m = 1  # number of matrices
  iseed = 137  # random seed

  dat_dir = 'rm-n%d-m%d' % (n, m)
  if not os.path.isdir(dat_dir):
    os.mkdir(dat_dir)

  np.random.seed(iseed)
  for im in range(m):
    cmat = np.random.rand(n, n)
    fout = os.path.join(dat_dir, 'cmat%03d.dat' % im)
    np.savetxt(fout, cmat)
    fout = os.path.join(dat_dir, 'tmat%03d.dat' % im)
    np.savetxt(fout, cmat.T)
# end __main__
