#!/usr/bin/env python3
import os
import sys
import numpy as np
from timeit import default_timer as timer
from ceperley.lsapr import lsapr

if __name__ == '__main__':
  outdir = sys.argv[2]
  fmat = sys.argv[1]
  fmat = fmat.replace('cmat', 'tmat')
  assert os.path.basename(fmat).startswith('tmat')
  cmat = np.loadtxt(fmat)
  start = timer()
  ret = lsapr(cmat)
  end = timer()
  print(end-start)
  phi = ret[0]-1
  z = ret[1]

  fout = os.path.join(outdir, 'out1.dat')
  np.savetxt(fout, [z])
  with open(fout, 'a') as f:
    np.savetxt(f, phi, fmt='%d')
# end __main__
