#!/usr/bin/env python3
import os
import sys
import numpy as np
from timeit import default_timer as timer
from scipy.optimize import linear_sum_assignment

if __name__ == '__main__':
  outdir = sys.argv[2]
  fmat = sys.argv[1]
  cmat = np.loadtxt(fmat)
  start = timer()
  irow, icol = linear_sum_assignment(cmat)
  z = cmat[irow, icol].sum()
  end = timer()
  print(end-start)
  phi = icol
  fout = os.path.join(outdir, 'out2.dat')
  np.savetxt(fout, [z])
  with open(fout, 'a') as f:
    np.savetxt(f, phi, fmt='%d')
# end __main__
